--- ./apps/app_voicemail.c	2004-09-01 19:23:32.000000000 -0700
+++ ./apps/app_voicemail.c.explain-silence-and-length-states	2004-09-01 19:24:31.000000000 -0700
@@ -1241,6 +1241,8 @@
 					
 					if (totalsilence > maxsilence) {
 					/* Ended happily with silence */
+					if (option_verbose > 2) 
+						ast_verbose( VERBOSE_PREFIX_3 "Recording automatically stopped after a silence of %d seconds\n", totalsilence/1000);
 					ast_frfree(f);
 					gotsilence = 1;
 					outmsg=2;
@@ -1459,6 +1461,8 @@
 
 					if (totalsilence > maxsilence) {
 					/* Ended happily with silence */
+                                        if (option_verbose > 2)
+                                                ast_verbose( VERBOSE_PREFIX_3 "Recording automatically stopped after a silence of %d seconds\n", totalsilence/1000);
 					ast_frfree(f);
 					gotsilence = 1;
 					outmsg=2;
@@ -1893,7 +1897,10 @@
 						close(fd);
 				}
 				if (duration < vmminmessage) {
+					if (option_verbose > 2) 
+						ast_verbose( VERBOSE_PREFIX_3 "Recording was %d seconds long but needs to be at least %d - abandoning\n", duration, vmminmessage);
 					vm_delete(fn);
+					/* XXX We should really give a prompt too short/option start again, with leave_vm_out called only after a timeout XXX */
 					goto leave_vm_out;
 				}
 				/* Are there to be more recipients of this message? */
@@ -4259,6 +4266,8 @@
 		if ((s = ast_variable_retrieve(cfg, "general", "minmessage"))) {
 			if (sscanf(s, "%d", &x) == 1) {
 				vmminmessage = x;
+				if (maxsilence <= vmminmessage)
+					ast_log(LOG_WARNING, "maxsilence should be less than minmessage or you may get empty messages\n");
 			} else {
 				ast_log(LOG_WARNING, "Invalid min message time length\n");
 			}
